package provide reftrace 1.0
namespace eval ::reftrace { 
    variable seq 0 
    namespace export {[a-z]*}
}
namespace eval ::reftrace::v {}
proc ::reftrace::lindex& {listVarName args} {
    upvar 1 $listVarName lv
    MkRefLowLevel [list ::lindex $args]  [list ::lset $args] 0 lv
}
proc ::reftrace::dict& {dictVarName args} {
    upvar 1 $dictVarName dv
    MkRefLowLevel [list {::dict get} $args]  [list {::dict set} $args] 0 dv
}
proc ::reftrace::lindex* {listVarName args} {
    upvar 1 $listVarName lv
    MkRefLowLevel [list ::lindex $args]  [list ::lset $args] 1 lv
}
proc ::reftrace::dict* {dictVarName args} {
    upvar 1 $dictVarName dv
    MkRefLowLevel [list {::dict get} $args]  [list {::dict set} $args] 1 dv
}
proc ::reftrace::MkRefLowLevel {inConv outConv isTemporal structureVarName} {
    # We will assign traces to the data structure
    upvar 1 $structureVarName structureVar
    # Initialize it (may be useful sometimes) [FIXME: explain]
    if {![info exists structureVar]} {
        set structureVar {}
    }
    set linkedName [MkName]
    upvar \#0 $linkedName linkedVar
    foreach {cvpre cvpost} $inConv {break}
    # Used to be {expand} :-(
    set linkedVar [eval [lrange $cvpre 0 end] [list $structureVar] [lrange $cvpost 0 end]]
    trace add variable structureVar {write read unset}  [list ::reftrace::Tracker $linkedName $inConv $outConv $isTemporal]
    return $linkedName
}
proc ::reftrace::Tracker {linkedName inConv outConv isTemporal name1 name2 op} {
    # The linked var is always unset when the data structure var is.
    # For temporary ('unaliased') references, the linked var is
    # also unset when the data structure is written.
    if {($op eq "unset")||($op eq "write" && $isTemporal)} {
        unset $linkedName
    } elseif {$op eq "write"} {
        # For non-temporal references, we update linked var when
        # the data structure is written.
        if {$name2 eq ""} {
            upvar 1 $name1 myvar
        } else {
            upvar 1 ${name1}($name2) myvar
        }
        foreach {cvpre cvpost} $inConv {break}
        set $linkedName [eval [lrange $cvpre 0 end] [list $myvar] [lrange $cvpost 0 end]]
    } elseif {$op eq "read"} {
        # Someone tries to read a data structure...
        if {$name2 eq ""} {
            upvar 1 $name1 myvar
        } else {
            upvar 1 ${name1}($name2) myvar
        }
        # Time to put the value back
        foreach {cvpre cvpost} $outConv {break}
        # If someone didn't unset linked var yet
        if {[info exists $linkedName]} {
	    eval [lrange $cvpre 0 end] [list myvar] [lrange $cvpost 0 end] [list [set $linkedName]]
        } else {
            # The link is destroyed, trace is not necessary
            trace remove variable myvar {write read unset}  [list ::reftrace::Tracker  $linkedName $inConv $outConv $isTemporal]
        }
        # Temporal link is removed when the structure is first read.
        if {$isTemporal} {
            unset $linkedName
            trace remove variable myvar {write read unset}  [list ::reftrace::Tracker  $linkedName $inConv $outConv $isTemporal]
        }
    }
}
proc ::reftrace::MkName {} {
    return ::reftrace::v::[incr ::reftrace::seq]
}
